// LED Matrix Blink example  for  LED GAME + Arduino

#define LEDWIDTH  16
#define LED_PORT  PORTB
#define LED_DDR   DDRB
#define LED_CLK   0
#define LED_LATCH 1
#define LED_DATA  2

unsigned int ledvram[LEDWIDTH*2];
int tic;
int blink;

void led_port_init(void)
{
  LED_DDR  |=  ((1<<LED_LATCH)|(1<<LED_CLK)|(1<<LED_DATA));
  LED_PORT &= ~((1<<LED_CLK)|(1<<LED_LATCH));
}

void led_disp(void)
{
  for (int row=0;row<LEDWIDTH;row++) {
    unsigned int temp = 1<<row;
    led_sendword(ledvram[(int)row+16]);
    led_sendword(~temp);
    led_sendword(ledvram[(int)row]);
    LED_PORT |= (1<<LED_LATCH);
    LED_PORT &= ~(1<<LED_LATCH);
 }
}

void led_sendword(unsigned int dat)
{
  for (int bitcnt=0;bitcnt<LEDWIDTH;bitcnt++) {
    if (dat & 0x8000) { LED_PORT |=  (1<<LED_DATA); }
    else              { LED_PORT &= ~(1<<LED_DATA); }
    dat <<= 1;
    LED_PORT |=  (1<<LED_CLK);
    LED_PORT &= ~(1<<LED_CLK);
  }
}

void setup()                    // run once, when the sketch starts
{
  led_port_init();
  tic=0; blink=0;
}

void loop()                     // run over and over again
{
  if (tic-- <= 0) {
    tic=1000;
    blink=(blink+1)%2;
    for (int i=0;i<LEDWIDTH*2;i++) { ledvram[i] = 0xFFFF; }
    if (blink&1) {
      for (int i=0;i<LEDWIDTH;i++) { ledvram[i] = 0x0000;  } // RED
      //for (int i=0;i<LEDWIDTH;i++) { ledvram[i+LEDWIDTH] = 0x0000; } //GREEN
    }
  }
  led_disp();
}

// main() {
//   setup();
//   while (1) { loop(); }
// }
